#set rootWindow ""

set tipsytop(R) 1.0
set tipsytop(R_min) 1.0
set tipsytop(R_max) 1.0
set tipsytop(theta) 60
set tipsytop(theta_min) 0
set tipsytop(theta_max) 80
set tipsytop(r) 0.2
set tipsytop(r_min) 0 
set tipsytop(r_max) 0.7
set tipsytop(H) 0.7 
set tipsytop(h) 0.35 
set tipsytop(theta_slices) 16
set tipsytop(theta_slices_min) 3 
set tipsytop(theta_slices_max) 32 
set tipsytop(z_slices) 10
set tipsytop(z_slices_min) 1
set tipsytop(z_slices_max) 32 

proc UpdateTipsyTop { scaler pTipsytop value } {
    global $pTipsytop

    # Keep R in range
    if { [subst $[subst $pTipsytop](R)] < [subst $[subst $pTipsytop](R_min)] } {
	set [subst $pTipsytop](R) [subst $[subst $pTipsytop](R_min)]
    } elseif { [subst $[subst $pTipsytop](R)] > [subst $[subst $pTipsytop](R_max)] } {
	set [subst $pTipsytop](R) [subst $[subst $pTipsytop](R_max)]
    }

    # Keep theta in range
    if { [subst $[subst $pTipsytop](theta)] < [subst $[subst $pTipsytop](theta_min)] } {
	set [subst $pTipsytop](theta) [subst $[subst $pTipsytop](theta_min)]
    } elseif { [subst $[subst $pTipsytop](theta)] > [subst $[subst $pTipsytop](theta_max)] } {
	set [subst $pTipsytop](theta) [subst $[subst $pTipsytop](theta_max)]
    }

    set theta [expr [subst $[subst $pTipsytop](theta)] * 3.1415927 / 180.0]

    set [subst $pTipsytop](H) [expr [subst $[subst $pTipsytop](R)] * cos($theta)]

    set [subst $pTipsytop](r_min) 0
    set [subst $pTipsytop](r_max) [expr [subst $[subst $pTipsytop](R)] * sin($theta)]

    # Keep r in range
    if { [subst $[subst $pTipsytop](r)] < [subst $[subst $pTipsytop](r_min)] } {
	set [subst $pTipsytop](r) [subst $[subst $pTipsytop](r_min)]
    } elseif { [subst $[subst $pTipsytop](r)] > [subst $[subst $pTipsytop](r_max)] } {
	set [subst $pTipsytop](r) [subst $[subst $pTipsytop](r_max)]
    }

    # Calculate h

    set Y [expr [subst $[subst $pTipsytop](R)] / cos($theta)]
    set y [expr [subst $[subst $pTipsytop](r)] * tan($theta)]

    set [subst $pTipsytop](h) [expr $Y - $y - [subst $[subst $pTipsytop](H)]]

    # Display
    #puts "H = [subst $[subst $pTipsytop](H)]"
    #puts "h = [subst $[subst $pTipsytop](h)]"
}

# Create UI
toplevel $rootWindow.tipsytop

scale $rootWindow.tipsytop.scaleR -label "R" -from $tipsytop(R_min) -to $tipsytop(R_max) -resolution 0.01 -tickint 1 -length 400 -orient horizontal -variable tipsytop(R) -command [list UpdateTipsyTop $rootWindow.tipsytop.scaler tipsytop]
pack $rootWindow.tipsytop.scaleR -side top -fill x

scale $rootWindow.tipsytop.scaletheta -label "theta" -from $tipsytop(theta_min) -to $tipsytop(theta_max) -resolution 1 -tickint 10 -length 400 -orient horizontal -variable tipsytop(theta) -command [list UpdateTipsyTop $rootWindow.tipsytop.scaler tipsytop]
pack $rootWindow.tipsytop.scaletheta -side top -fill x

scale $rootWindow.tipsytop.scaler -label "r" -from $tipsytop(r_min) -to $tipsytop(R_max) -resolution 0.01 -tickint 0.5 -length 400 -orient horizontal -variable tipsytop(r) -command [list UpdateTipsyTop $rootWindow.tipsytop.scaler tipsytop]
pack $rootWindow.tipsytop.scaler -side top -fill x

scale $rootWindow.tipsytop.scalethetaslices -label "theta slices" -from $tipsytop(theta_slices_min) -to $tipsytop(theta_slices_max) -resolution 1 -tickint 29 -length 400 -orient horizontal -variable tipsytop(theta_slices)
pack $rootWindow.tipsytop.scalethetaslices -side top -fill x

scale $rootWindow.tipsytop.scalezslices -label "z slices" -from $tipsytop(z_slices_min) -to $tipsytop(z_slices_max) -resolution 1 -tickint 31 -length 400 -orient horizontal -variable tipsytop(z_slices)
pack $rootWindow.tipsytop.scalezslices -side top -fill x


