set SLF_PI 3.1415927

proc GenerateTorus { {pcName "Torus"} {fMajorRadius 1.0} {fMinorRadius 0.25} {iThetaSlices 16} {iPhiSlices 16} {fSMin 0.0} {fTMin 0.0} {fSMax 1.0} {fTMax 1.0} } {

    global SLF_PI

    set fDeltaTheta [expr 2.0 * $SLF_PI / $iThetaSlices]
    set fTheta 0
    set fDeltaPhi [expr -2.0 * $SLF_PI / $iPhiSlices]
    set fPhi 0

    set fDeltaS [expr double($fSMax - $fSMin) / $iPhiSlices]
    set fS $fSMin
    set fDeltaT [expr double($fTMax - $fTMin) / $iThetaSlices]
    set fT $fTMin

    set fPhi 0
    set fS $fSMin
    
    for { set j 0 } { $j <= $iPhiSlices } { incr j } {
	set fRNormal [expr cos($fPhi)]
	set fZNormal [expr sin($fPhi)]
	set fR [expr $fMajorRadius + $fMinorRadius*cos($fPhi)]
	set fZ [expr $fMinorRadius*sin($fPhi)]

	set fTheta 0
	set fT $fTMin
	
	for { set i 0 } { $i <= $iThetaSlices } { incr i } {
	    set vNormal [list [expr $fRNormal*cos($fTheta)] [expr $fRNormal*sin($fTheta)] $fZNormal]
	    set pt [list [expr $fR*cos($fTheta)] [expr $fR*sin($fTheta)] $fZ]

	    slide point "p[subst $pcName]_[subst $i]_[subst $j]" $pt -normal $vNormal -texture [list $fS $fT 0]

	    set fTheta [expr $fTheta + $fDeltaTheta]
	    set fT [expr $fT + $fDeltaT]
	}

	set fPhi [expr $fPhi + $fDeltaPhi]
	set fS [expr $fS + $fDeltaS]
    } 

    set iFaceID 0
    set listFaces ""

    for { set i 1 } { $i <= $iThetaSlices } { incr i } {
	for { set j 1 } { $j <= $iPhiSlices } { incr j } {
	    slide face "f[subst $pcName]_[subst $iFaceID]" [list "p[subst $pcName]_[expr $i - 1]_[expr $j - 1]" "p[subst $pcName]_[expr $i - 1]_[expr $j]" "p[subst $pcName]_[expr $i]_[expr $j - 1]"]
	    set listFaces "$listFaces f[subst $pcName]_[subst $iFaceID]"
	    incr iFaceID

	    slide face "f[subst $pcName]_[subst $iFaceID]" [list "p[subst $pcName]_[expr $i]_[expr $j - 1]" "p[subst $pcName]_[expr $i - 1]_[expr $j]" "p[subst $pcName]_[expr $i]_[expr $j]"]
	    set listFaces "$listFaces f[subst $pcName]_[subst $iFaceID]"
	    incr iFaceID
	}
    }

    slide object "o[subst $pcName]" $listFaces 
}
